CR .( Loading A register words...)
\ Address register store and fetch words
\ Sadly, there aren't any spare registers to make this as
\ efficient as it could be. However, it can still give a
\ useful improvement in loops, and in many cases also results
\ in cleaner-looking code.

HEX

VARIABLE A

\ Set the address register
FCODE A!  ( addr -- )
  43ED , A ,            \ ld (A),bc
  C1 C,                 \ pop bc
FNEXT

\ Get the address register
FCODE A@  ( -- addr )
  C5 C,                 \ push bc
  4BED , A ,            \ ld bc,(A)
FNEXT

\ Store cell at A
FCODE !A  ( u -- )
  2A C, A ,             \ ld hl,(A)
  71 C, 23 C, 70 C,     \ ld (hl),c  inc hl  ld (hl),b
  C1 C,                 \ pop bc
FNEXT

\ Fetch cell at A
FCODE @A  ( -- u )
  C5 C,                \ push bc
  2A C, A ,            \ ld hl,(A)
  4E C, 23 C, 46 C,    \ ld c,(hl)  inc hl  ld b,(hl)
FNEXT

\ Store char at A
FCODE C!A  ( c -- )
  2A C, A ,             \ ld hl,(A)
  71 C,                 \ ld (hl),c
  C1 C,                 \ pop bc
FNEXT

\ Fetch char at A
FCODE C@A  ( -- c )
  C5 C,                 \ push bc
  2A C, A ,             \ ld hl,(A)
  4E C, 06 C, 00 C,     \ ld c,(hl)  ld b,0
FNEXT

\ Store cell at A with increment
FCODE !A+  ( u -- )
  2A C, A ,             \ ld hl,(A)
  71 C, 23 C,           \ ld (hl),c  inc hl
  70 C, 23 C,           \ ld (hl),b  inc hl
  22 C, A ,             \ ld (A),hl
  C1 C,                 \ pop bc
FNEXT

\ Fetch cell at A with increment
FCODE @A+  ( -- u )
  C5 C,                 \ push bc
  2A C, A ,             \ ld hl,(A)
  4E C, 23 C,           \ ld c,(hl)  inc hl
  46 C, 23 C,           \ ld b,(hl)  inc hl
  22 C, A ,             \ ld (A),hl
FNEXT

\ Store char at A with increment
FCODE C!A+  ( c -- )
  2A C, A ,             \ ld hl,(A)
  71 C, 23 C,           \ ld (hl),c  inc hl
  22 C, A ,             \ ld (A),hl
  C1 C,                 \ pop bc
FNEXT

\ Fetch char at A with increment
FCODE C@A+  ( -- c )
  C5 C,                 \ push bc
  2A C, A ,             \ ld hl,(A)
  4E C, 23 C,           \ ld c,(hl)  inc hl
  06 C, 00 C,           \ ld b,0
  22 C, A ,             \ ld (A),hl
FNEXT

DECIMAL
