CR .( Loading Block/File converters...)
\ Utility words to convert between source blocks and text files
\ FILE>BLKS and BLKS>FILE are the most commonly used words, but
\ BLK>> and BLKS>> may also be useful.

\ Append a block to a file
: BLK>>  ( id block -- )
    BLOCK
    16 FOR  2DUP 64 -TRAILING ROT WRITE-LINE THROW
            64 +
       STEP  2DROP ;

\ Append blocks n to m to a file
: BLKS>> ( id blockn blockm -- )
    >R
    BEGIN  2DUP BLK>> 1+ DUP R@ U>  UNTIL
    2DROP R> DROP ;

\ Create file of blocks n to m
: BLKS>FILE ( caddr u blockn blockm -- )
    2SWAP W/O CREATE-FILE THROW
    DUP >R ROT ROT BLKS>> R>
    CLOSE-FILE THROW ;

\ Write a block from input file
: >>BLK ( id block -- flag )
    BLOCK DUP 1024 BLANK UPDATE
    16 FOR OVER PAD 65 ROT READ-LINE THROW
           0= IF  R> 2DROP 2DROP FALSE EXIT  THEN
           DUP 65 = ABORT" Line too long!"
           OVER PAD SWAP ROT CMOVE 64 +           
       STEP  2DROP TRUE ;

\ Transfer file to blocks starting at n
: FILE>BLKS ( caddr u blockn -- )
    ROT ROT R/O OPEN-FILE THROW >R
    BEGIN  R@ OVER >>BLK  WHILE  1+  REPEAT
    DROP R> CLOSE-FILE THROW ;
